trap - ERR; trap "abdie" ERR; bash -n "$0"

abinfo "Building Groovy ..."
gradle clean dist

for i in binary docs sdk; do
    abinfo "Extracting Groovy $i ..."
    unzip -o "$SRCDIR"/target/distributions/apache-groovy-$i-$PKGVER.zip
done

abinfo "Droping *.bat ..."
rm -v groovy-$PKGVER/bin/*.bat

abinfo "Installing documentations ..."
mkdir -p $PKGDIR/usr/share/doc/$PKGNAME

abinfo "Installing documentation ..."
for i in LICENSE NOTICE html licenses; do
    mv -vf "$SRCDIR"/groovy-$PKGVER/$i \
        "$PKGDIR"/usr/share/doc/$PKGNAME
done

abinfo "Installing runtime libraries ..."
mkdir -pv "$PKGDIR"/usr/lib
cp -rv "$SRCDIR"/groovy-$PKGVER \
    "$PKGDIR"/usr/lib/groovy

abinfo "Installing executable symlinks ..."
mkdir -pv "$PKGDIR"/usr/bin
for i in grape groovy groovyc groovyConsole groovydoc \
         groovysh java2groovy startGroovy; do
    ln -sv ../lib/groovy/bin/$i \
        "$PKGDIR"/usr/bin/$i
done

trap - ERR
